var app = angular.module('Anagrafica', ['ui.bootstrap','chieffancypants.loadingBar', 'ngAnimate'])
    .config(function($locationProvider,$httpProvider,cfpLoadingBarProvider) {
            $locationProvider.html5Mode(true);
            $locationProvider.html5Mode(true).hashPrefix('!');
            //Reset headers to avoid OPTIONS request (aka preflight)
            $httpProvider.defaults.headers.common = {};
            $httpProvider.defaults.headers.post = {};
            $httpProvider.defaults.headers.put = {};
            $httpProvider.defaults.headers.patch = {};
            cfpLoadingBarProvider.includeSpinner = true;
    });

app.filter('capitalize', function() {
    return function(input, all) {
        return (!!input) ? input.replace(/([^\W_]+[^\s-]*) */g, function(txt){return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();}) : '';
    }
});


app.directive('capitalizeFirst', function(uppercaseFilter, $parse) {
    return {
        require: 'ngModel',
        link: function(scope, element, attrs, modelCtrl) {
            var capitalize = function(inputValue) {
                //var capitalized = inputValue.charAt(0).toUpperCase() +
                //    inputValue.substring(1);
                var capitalized = inputValue.split(' ');
                var resultvalue="";
                for(var i=0;i<capitalized.length;i++) {
                    if (capitalized[i]!=""){
                    capitalized[i]=capitalized[i].charAt(0).toUpperCase() +
                    capitalized[i].substring(1);
                        if (resultvalue!=""){
                            resultvalue=resultvalue.concat(' ').concat(capitalized[i]);
                        }else{
                            resultvalue=capitalized[i];
                        }
                    }
                }

                if(resultvalue !== inputValue) {
                    modelCtrl.$setViewValue(resultvalue);
                    modelCtrl.$render();
                }
                return resultvalue;
            }
            var model = $parse(attrs.ngModel);
            modelCtrl.$parsers.push(capitalize);
            capitalize(model(scope));
        }
    };
});

app.directive('numbersOnly', function(){
    return {
        require: 'ngModel',
        link: function(scope, element, attrs, modelCtrl) {
            modelCtrl.$parsers.push(function (inputValue) {
                // this next if is necessary for when using ng-required on your input.
                // In such cases, when a letter is typed first, this parser will be called
                // again, and the 2nd time, the value will be undefined
                if (inputValue == undefined) return ''
                var transformedInput = inputValue.replace(/[^0-9]/g, '');
                if (transformedInput!=inputValue) {
                    modelCtrl.$setViewValue(transformedInput);
                    modelCtrl.$render();
                }

                return transformedInput;
            });
        }
    };
});

function MyCtrl($scope) {
    $scope.number = ''
};

app.controller('AnagraficaCtrl', function($scope, $http, $location, $sce,$anchorScroll,cfpLoadingBar){

    $scope.domanda={cognome:"",nome: "", sesso: "",data_di_nascita:"",prov_n:"",nato_a:"",telefono:"",telcell:"",email:"",indirizzo:"",cap:"",citta:"",provincia:"",cf:"",professione:"",inviato_da:"",note_an:"",cf:"",clinicloud:false,convenzionato:""};

    $scope.province=[];
    $scope.convenzioni=[];
    $scope.listacittanascita=[];
    $scope.listacitta=[];
    $scope.sessi=[{id:" ",v:" "},{id:"M",v:"M"},{id:"F",v:"F"}];
    $scope.curid=0;
    $scope.labelmessaggio="";
    $scope.compilaanamnesi="";
    $scope.filesalvataggio="";


    $scope.gotoAnchor = function(x) {
        if ($http.$$port){
            $http.$$port.watch()
        }
        var newHash = x;
        if ($location.hash() !== newHash) {
            // set the $location.hash to `newHash` and
            // $anchorScroll will automatically scroll to it
            $location.hash(x);
        } else {
            // call $anchorScroll() explicitly,
            // since $location.hash hasn't changed
            $anchorScroll();
        }

    };

    $scope.$watch("curid", function(newValue, oldValue) {
        if (newValue != oldValue) {
            $scope.$evalAsync( function() {
                $scope.gotoAnchor('top'+newValue);
            });
        }
    });

    function inizializzaprovince(prov){
            var i=0;
            angular.forEach(prov, function(p) {
                if (p.p=="EE"){
                    prov.splice(prov.indexOf(p), 1);
                }

            });

            angular.forEach(prov, function(p) {
                if (p.p=="STRANIERO") {
                    p.l= "EE";
                } else if (p.p=="EE"){
                    prov.splice(prov.indexOf(p), 0);
                }else{
                    p.l= p.p;
                }

            });

            v={p:' ',l:' '};
            prov.unshift(v);
            $scope.province =   prov ;
            $scope.domanda.prov_n= prov[0].l;
            $scope.domanda.provincia= prov[0].l;

    }

    function inizializzaconvenzioni(con){
        var i=0;

        angular.forEach(con, function(p) {
            p.l= p.p;
        });

        v={p:' ',l:' '};
        con.unshift(v);
        $scope.convenzioni =  con ;
        $scope.domanda.convenzionato = "";
    }

    $scope.init = function () {
        $scope.datedetected();
        $scope.ipchiamante=$location.search()["ip"];
        $scope.compilaanamnesi=$location.search()["a"];
        $scope.filesalvataggio=$location.search()["f"];
        $scope.domanda.sesso=$scope.sessi[0].v;
        $scope.fi=$location.search()["fi"];
        if (!$scope.fi){
            $scope.fi=0;
        }

        if ( !$scope.filesalvataggio) {
            $scope.filesalvataggio=0;
        };
        if ((!$scope.compilaanamnesi)||($scope.compilaanamnesi=="")){
            $scope.compilaanamnesi=0;
        };

        $scope.showdivprincipale=true;
        $scope.showlabelmessaggio=false;

        var s=false;
        if($scope.ipchiamante){
            $http.post('http://'+$scope.ipchiamante+':9000/anagrafica/province.json')
                .success(function(response) {
                    inizializzaprovince(response);

                    $http.post('http://'+$scope.ipchiamante+':9000/anagrafica/convenzioni.json')
                        .success(function(response) {
                            inizializzaconvenzioni(response);
                        });

                }).error(function(data, status) {

                    $scope.showlabelmessaggio=true;
                    $scope.labelmessaggio=$sce.trustAsHtml("Errore nel caricamento della lista delle province");

                    $scope.showmsgsecondario=true;
                    var msg2 = "Verificare che il server dati di Horizon sia raggiungibile";
                    if ($scope.ipchiamante) {
                        msg2 = msg2 + " o se stai utilizzando Internet Explorer 11 controlla le impostazioni sicurezza aggiungendo tra i siti attendibili l 'indirizzo <font style='color: #cd0a0a'> http://"+$scope.ipchiamante+"</font>";
                    }
                    $scope.labelmessaggiosecondario=$sce.trustAsHtml(msg2);

                });
        } else{
            $http.post('http://studio.caes.it:9000/anagrafica/province.json')
                .success(function(response) {
                    inizializzaprovince(response);

                    $http.post('http://studio.caes.it:9000/anagrafica/convenzioni.json')
                        .success(function(response) {
                            inizializzaconvenzioni(response);
                        });
                }).error(function(data, status) {
                    $scope.showmsgsecondario=true;
                    var msg2 = "server caes non raggiungibile ";
                    msg2 = msg2 + " se stai utilizzando Internet Explorer 11 controlla le impostazioni sicurezza aggiungendo tra i siti attendibili l 'indirizzo <font style='color: #cd0a0a'> http://studio.caes.it</font>";
                    $scope.labelmessaggiosecondario=$sce.trustAsHtml(msg2);
                });
        }
    }

    $scope.datedetected=function(){
        if(!Modernizr.inputtypes.date) {
            $scope.supportodate = false
        }else{
            $scope.supportodate = true
        }
    };
    $scope.data_di_nascitaconv=function(d){
        if (d!=""){
        var convertedDate = new Date(d);
        return convertedDate;
        }

    }

    function inizializzacomuni(comuni,id){
        var i=0;
        angular.forEach(comuni, function(p) {
                p.l= p.p;
        });
        v={p:' ',l:' '};
        comuni.unshift(v);
        if (id==1){
            $scope.listacittanascita =   comuni
            $scope.domanda.nato_a= comuni[0].l;
            $scope.gotoAnchor('labelcomunenas');
        }else{
            $scope.listacitta =   comuni
            $scope.domanda.citta= comuni[0].l;
            $scope.gotoAnchor('labelcitta');
        }
    }
    $scope.richiedicomuni = function(id){

        if (id==1){
            p={provincia:$scope.domanda.prov_n};
        }else{
            p={provincia:$scope.domanda.provincia};
        }

        if (p.provincia==" "){
            if (id==1){
                $scope.listacittanascita=[];
                $scope.domanda.nato_a="";
            }else{
                $scope.listacitta =[] ;
                $scope.domanda.citta="";
            }
        }else{
        $http.post('http://'+$scope.ipchiamante+':9000/anagrafica/comuni.json',p)
            .success(function(response) {
                inizializzacomuni(response,id)
                $scope.showlabelmessaggio=false;

            }).error(function(data, status) {
                $http.post('http://studio.caes.it:9000/anagrafica/comuni.json',p)
                    .success(function(response) {
                        inizializzacomuni(response,id)
                        $scope.showlabelmessaggio=false;
						cfpLoadingBar.complete();
                    }).error(function(data, status) {

                        $scope.showlabelmessaggio=true;
                        $scope.labelmessaggio=$sce.trustAsHtml("Errore nel caricamento della lista di comuni");
                        alert( "failure message: " + JSON.stringify({data: response}));
						cfpLoadingBar.complete();                  
				  });

                //$scope.showlabelmessaggio=true;
                //$scope.labelmessaggio=$sce.trustAsHtml("Errore nel caricamento della lista di comuni");
                //alert( "failure message: " + JSON.stringify({data: response}));
            });
        }
    }

    function getIndexOf(arr, val, prop) {
        var l = arr.length,
            k = 0;
        for (k = 0; k < l; k = k + 1) {
            if (arr[k][prop] === val) {
                return k;
            }
        }
        return false;
    }
    $scope.open = function($event) {
        $event.preventDefault();
        $event.stopPropagation();

        $scope.opened = true;
    };

    $scope.calcolacf =function(){
        if($scope.ipchiamante){

            $http.post('http://' + $scope.ipchiamante + ':9000/anagrafica/cf.json', $scope.domanda)
                .success(function (response, status) {
                    if (status == 201) {
                        $scope.cf=response.cf;
                    }else if (status == 202) {
                        $scope.cf=response.cf;
                    }else {
                        $scope.cf=response.cf;
                    }
                }).error(function (data, status) {
                    $http.post('http://studio.caes.it:9000/anagrafica/cf.json', $scope.domanda)
                        .success(function (response, status) {
                            if (status == 201) {
                                $scope.cf="";
                                alert("failure message: " + JSON.stringify({data: response}));
                            } else {
                                $scope.cf=response;
                            }
                        }).error(function (data, status) {
                            $scope.cf="";
                            alert("failure message: " + JSON.stringify({data: response}));
                        });
                });
        }else{
            $http.post('http://studio.caes.it:9000/anagrafica/cf.json', $scope.domanda)
                .success(function (response, status) {
                    if (status == 201) {
                        $scope.cf=response;
                    }else if (status == 202) {
                        $scope.cf=response;
                    }else {
                        $scope.cf=response;
                    }
                }).error(function (data, status) {
                    alert("failure message: " + JSON.stringify({data: response}));

                });

        }
	};

    $scope.avanti = function () {
        if ($scope.curid == 4) {
            $http.post('http://' + $scope.ipchiamante + ':9000/anagrafica/cf.json', $scope.domanda)
                .success(function (response, status) {
                    if (status == 201) {
                        $scope.domanda.cf = "";
                        $scope.showlabelmessaggio = true;
                        $scope.labelmessaggio = $sce.trustAsHtml(data + " " + response);
                        alert("failure message: " + JSON.stringify({data: response}));
                    }else if (status == 202) {
                        $scope.cf=response.cf;
                        if ($scope.cf) {
                            $scope.showclinicloud=response.clinicloud;
                            $scope.domanda.cf = $scope.cf;
                        }else{
                            $scope.showclinicloud=false;
                            $scope.domanda.cf = response;
                        }
                        $scope.curid += 1;
                    }else {
                        $scope.cf=response.cf;
                        if ($scope.cf) {
                            $scope.showclinicloud=response.clinicloud;
                            $scope.domanda.cf = $scope.cf;
                        }else{
                            $scope.showclinicloud=false;
                            $scope.domanda.cf = response;
                        }
                        $scope.curid += 1;
                    }
                }).error(function (data, status) {
                    $http.post('http://studio.caes.it:9000/anagrafica/cf.json', $scope.domanda)
                        .success(function (response, status) {
                            if (status == 201) {
                                $scope.domanda.cf = "";
                                $scope.showlabelmessaggio = true;
                                $scope.labelmessaggio = $sce.trustAsHtml(data + " " + response);
                                alert("failure message: " + JSON.stringify({data: response}));
                            } else {
                                $scope.domanda.cf = response;
                                $scope.curid += 1;
                            }
                        }).error(function (data, status) {
                            $scope.domanda.cf = "";
                            $scope.showlabelmessaggio = true;
                            $scope.labelmessaggio = $sce.trustAsHtml(data + " " + response);
                            alert("failure message: " + JSON.stringify({data: response}));
                        });
                    //$scope.domanda.cf = "";
                    //$scope.showlabelmessaggio = true;
                    //$scope.labelmessaggio = $sce.trustAsHtml(data + " " + response);
                    //alert("failure message: " + JSON.stringify({data: response}));
                });
        } else {
            $scope.curid += 1;
        }

    }
    $scope.indietro = function() {
        $scope.curid += -1;
    }

    var changeLocation = function(url, forceReload) {
        $scope = $scope || angular.element(document).scope();
        if(forceReload || $scope.$$phase) {
            window.location = url;
        }
        else {
            //only use this if you want to replace the history stack
            //$location.path(url).replace();

            //this this if you want to change the URL and add it to the history stack
            $location.path(url);
            $scope.$apply();
        }
    };

    $scope.goHome=function(){
        changeLocation('/index.html?ip=' + $scope.ipchiamante, true);
    }

    $scope.fine = function() {
        $http.post('http://'+$scope.ipchiamante+':9000/anagrafica/nuova.json?f='+ $scope.filesalvataggio+'&a='+$scope.compilaanamnesi,$scope.domanda)
            .success(function(response, status) {
                if (status==201){
                    $scope.showdivprincipale = false;
                    $scope.curid = -1;
                    $scope.showlabelmessaggio = true;
                    $scope.labelmessaggio=$sce.trustAsHtml(response.message);
                }else {
                    $scope.m=response.message;
                    $scope.d=response.doc;
                    if ($scope.compilaanamnesi==1){
                        if ($scope.m) {
                            changeLocation('/anamnesi.html?id=' + $scope.m + '&ip=' + $scope.ipchiamante+ '&doc=' +$scope.d+ '&fi=' +$scope.fi, true);
                        }  else{
                            changeLocation('/anamnesi.html?id=' + response+ '&ip=' + $scope.ipchiamante+ '&fi=' +$scope.fi, true);
                        }
                    }else{
                        if($scope.d){
                            if ($scope.d==true){
                                alert( "Grazie per aver completato l'anagrafica. Si prega di continuare con la compilazione dei documenti");
                                changeLocation('http://'+$scope.ipchiamante+':9000/documenti?id=' + $scope.m+ '&fi=' +$scope.fi, true);
                            }else{
                                $scope.showdivprincipale = false;
                                $scope.curid = -1;
                                $scope.showlabelmessaggio = true;
                                $scope.labelmessaggio = $sce.trustAsHtml("Grazie per aver completato l'anagrafica. Si prega di rivolgersi al personale di studio");
                            }
                        }else {
                            $scope.showdivprincipale = false;
                            $scope.curid = -1;
                            $scope.showlabelmessaggio = true;
                            $scope.labelmessaggio = $sce.trustAsHtml("Grazie per aver completato l'anagrafica. Si prega di rivolgersi al personale di studio");
                        }
                    }

                }
            }).error(function(data, status) {
                $scope.showlabelmessaggio=true;
                $scope.labelmessaggio=$sce.trustAsHtml(data+" "+response);
                alert( "failure message: " + JSON.stringify({data: response}));
            });
    }

    $scope.annullaanagrafica = function() {
        var retVal = confirm("Vuoi annullare l'introduzione dei dati anagrafici?");
        if (retVal == true) {
            $scope.showdivprincipale=false;
            $scope.curid =-1;
            $scope.showlabelmessaggio=true;
            $scope.labelmessaggio = $sce.trustAsHtml("Inserimento Anagrafica annullato. Si prega di rivolgersi al personale di studio");
        }
    }

});

app.controller('principaleCtrl', function($scope, $http, $location, $sce){
    $scope.intestazione="Intestazione Studio"

    $scope.initindex = function () {
        $scope.ipchiamante=$location.search()["ip"];
        $scope.filesalvataggio=$location.search()["f"];
        if ( !$scope.filesalvataggio) {
            $scope.filesalvataggio=0;
        };
        if ($scope.ipchiamante){
            $http.post('http://'+$scope.ipchiamante+':9000/intestazione.json')
                .success(function(response, status) {
                    if (status==201){
                        $scope.intestazione=$sce.trustAsHtml("Error intestazione studio");
                    }else {
                        $scope.intestazione=$sce.trustAsHtml(response);
                    }
                }).error(function(data, status) {

                    $scope.showlabelmessaggio=true;
                    $scope.labelmessaggio=$sce.trustAsHtml("Errore nel caricamento dell'intestazione studio");

                    $scope.showmsgsecondario=true;
                    var msg2 = "Verificare che il server dati di Horizon sia raggiungibile";
                    if ($scope.ipchiamante) {
                        msg2 = msg2 + " o se stai utilizzando Internet Explorer 11 controlla le impostazioni sicurezza aggiungendo tra i siti attendibili l 'indirizzo <font style='color: #cd0a0a'> http://"+$scope.ipchiamante+"</font>";
                    }
                    $scope.labelmessaggiosecondario=$sce.trustAsHtml(msg2);
                });
        }else{
            $scope.showlabelmessaggio=true;
            $scope.showmsgsecondario=true;
            var msg2 = "Sei in modalit&agrave demo. Verificare che il server dati di Horizon sia raggiungibile";
            $scope.labelmessaggiosecondario=$sce.trustAsHtml(msg2);

        }
    }
});
